#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <iostream.h>
#include <fstream.h>
#include <time.h>
#include <math.h>
#include "global.h"

void comment_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  unsigned long       delta_zeit;
           char       *comment, mess[256];
           int        t_std, t_min, t_sec;
	   short      found=0;
	   int        i=0, j=0, xpos=LMAR;
           GC         gc;
           Display    *dpy=XtDisplay(drawing_a);
	   Window     window=XtWindow(drawing_a);;
           Dimension  width, height;

  extern void set_color(Widget, String, GC);

  /* get time since recording */
  delta_zeit=(unsigned long) (time(NULL)-initial_zeit);
  t_std=(int)(floor(delta_zeit/3600));
  t_min=(int)(floor((delta_zeit-t_std*3600)/60));
  t_sec=(int)(delta_zeit-t_std*3600-t_min*60);

  /* get graphics context */
  gc=XCreateGC(dpy, RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);
  XtVaGetValues(drawing_a, XmNwidth, &width, XmNheight, &height, NULL);
  found=0; i=0; j=0;
  while (!found || i>=8) {
    if (ch[i].active) {
      found=1;
      if (!ch[i].addfirst) xpos=ch[i].xpos;
      else xpos=reg.xpix+ch[i].xpos-ch[i].last-1;
    }
    for (j=0; j<7; j++) {
      if (!found && dch[i].ch[j].active) {
	found=1;
      if (!dch[i].ch[j].addfirst) xpos=dch[i].ch[j].xpos;
      else xpos=reg.xpix+dch[i].ch[j].xpos-dch[i].ch[j].last-1;
      }
    }
    i++;
  }
  set_color(drawing_a, "red", gc);
  XDrawLine(dpy, window, gc, xpos+LMAR, 0, xpos+LMAR, height);

  /* get comment */
  comment=XmTextGetString(comment_label);
  /* format time and write to comment file */
  sprintf(mess,"%.2d:%.2d:%.2d", t_std, t_min, t_sec);
  commentdat << mess << "\t" << comment << "\n";

  /* empty text widget and free memory */
  XmTextSetString(comment_label, "");
  XtFree(comment);
  XFreeGC(dpy, gc);
}
